###
# Program: Company employees
# Author:  Andre S Lessa
###

### import modules

import types

class Employee:
    "Generic class for all company employees"

    __employees = 0

    def __init__(self,name,salary=500.00):
        self.name = name
        self.salary = salary
        self.family = []
        Employee.__employees = Employee.__employees + 1

    def __str__(self):
        return "employee: %s" % self.name

    def raisesalary(self, percent):
        self.salary = self.salary + (self.salary * (1.0/percent))

    def job(self):
        print self.name, "writes Python code."

    def hasfamily(self):
        return len(self.family) > 0

    def addmember(self, name):
        self.family.append(name)

    def removemember(self, arg):
        if len(self.family) > 0:
            if type(arg) == type(1):
                self.removemember_int(arg)
            elif isinstance(arg, types.StringType):
                self.removemember_str(arg)

    def removemember_int(self, index):
        member = self.family[index]
        del self.family[index]
        return member

    def removemember_str(self, name):
        for member in self.family:
            if member == name:
                del self.family[self.family.index(member)]
                return member

    def __getitem__(self, index):
        member = self.family[index]
        return member

class Leader(Employee):
    "Company's Leader of the employees"
    def __init__ (self, name):
        Employee.__init__ (self, name, 1500.00)
    def job(self):
        print self.name, "supervises who writes Python code."

def totalemployee():
    return  Employee._employee__employees


