VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Parking Lot"
   ClientHeight    =   3135
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   7200
   LinkTopic       =   "Form1"
   ScaleHeight     =   3135
   ScaleWidth      =   7200
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox Vehicles 
      Height          =   2400
      Left            =   0
      TabIndex        =   5
      Top             =   480
      Width           =   5295
   End
   Begin VB.CommandButton CmdUnpark 
      Caption         =   "Unpark"
      Height          =   495
      Left            =   5760
      TabIndex        =   3
      Top             =   1080
      Width           =   1095
   End
   Begin VB.CommandButton CmdUpdate 
      Caption         =   "Update Info"
      Height          =   495
      Left            =   5760
      TabIndex        =   2
      Top             =   1680
      Width           =   1095
   End
   Begin VB.CommandButton cmdPark 
      Caption         =   "Park"
      Height          =   495
      Left            =   5760
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.CommandButton cmdInitializeServer 
      Caption         =   "Start Server"
      Height          =   495
      Left            =   5760
      TabIndex        =   0
      Top             =   2400
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Vehicles"
      Height          =   255
      Left            =   6120
      TabIndex        =   7
      Top             =   120
      Width           =   855
   End
   Begin VB.Label lbvehicles_number 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   5400
      TabIndex        =   6
      Top             =   120
      Width           =   495
   End
   Begin VB.Label lblStatus 
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   0
      Width           =   5055
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public ParkingServer As Object
Public newVehicle As Object
Private Sub cmdPark_Click()
    Set newVehicle = CreateObject("Python.Vehicle")
    newVehicle.floor = 1
    newVehicle.model = ""
    newVehicle.license = ""
    newVehicle.Color = ""
    If frmVehicle.ModifyInfo(newVehicle) Then
        ParkingServer.ParkVehicle newVehicle.floor, newVehicle.model, newVehicle.license, newVehicle.Color
        RefreshVehiclesList
    End If
    Set newVehicle = Nothing
End Sub

Private Sub CmdUnpark_Click()
    Dim CarSpot As Integer
    Dim Vehicle As Object
    If Vehicles.ListIndex = -1 Then
       Exit Sub
    Else
       CarSpot = Vehicles.ListIndex
       ParkingServer.UnparkVehicle CarSpot
       RefreshVehiclesList
    End If
End Sub

Private Sub cmdUpdate_Click()
    Dim CarSpot As Integer, Vehicle As Object
    If Vehicles.ListIndex = -1 Then
       Exit Sub
    Else
       CarSpot = Vehicles.ListIndex
       Set Vehicle = ParkingServer.IdentifyVehicle(CarSpot)
       If frmVehicle.ModifyInfo(Vehicle) Then RefreshVehiclesList
    End If
End Sub

Private Sub cmdInitializeServer_Click()
     If ParkingServer Is Nothing Then
        On Error GoTo cmdInitializeServer_Click_CreationError
        Set ParkingServer = CreateObject("Python.ParkingServer")
        On Error GoTo 0
        lblStatus.Caption = "The ParkingServer is up and running..."
        cmdInitializeServer.Caption = "&Stop Server"
        Vehicles.Visible = True
        cmdPark.Visible = True
        CmdUpdate.Visible = True
        CmdUnpark.Visible = True
        Label2.Visible = True
        lbvehicles_number.Visible = True
        RefreshVehiclesList
        Vehicles.ListIndex = 0
        Vehicles.SetFocus
        Exit Sub
     Else
         Vehicles.Visible = False
         cmdPark.Visible = False
         CmdUpdate.Visible = False
         CmdUnpark.Visible = False
         lbvehicles_number.Visible = False
         Label2.Visible = False
         Set ParkingServer = Nothing
         cmdInitializeServer.Caption = "&Start Server"
         lblStatus.Caption = "The ParkingServer is not running."
         Exit Sub
     End If
cmdInitializeServer_Click_CreationError:
    MsgBox "An error has happened while initializing the ParkingServer."
End Sub

Public Sub RefreshVehiclesList()
    Dim VehiclesList As Variant, VehiclesInList As Variant, highlighted As Integer
    lbvehicles_number.Caption = ParkingServer.GetVehiclesCount
    highlighted = Vehicles.ListIndex
    Vehicles.Clear
    VehiclesList = ParkingServer.GetLocationList
    For Each VehiclesInList In VehiclesList
        Vehicles.AddItem VehiclesInList
    Next VehiclesInList
    If highlighted < Vehicles.ListCount Then Vehicles.ListIndex = highlighted
    Vehicles.SetFocus
End Sub

Private Sub Form_Load()
    Vehicles.Visible = False
    cmdPark.Visible = False
    CmdUpdate.Visible = False
    CmdUnpark.Visible = False
    Label2.Visible = False
    lblStatus.Caption = "The ParkingServer is not running."
End Sub
